# Represents one part of GPX trail. Contains tools for dealing with the segment.
require 'enumerator'

class GpxSegment
  attr_reader :coordinates_array

  def initialize(acoordinates_array)
    @coordinates_array = acoordinates_array
  end

  def first; @coordinates_array.first end
  def last; @coordinates_array.last end
  def endpoints; [self.first,self.last] end
  def length # in metres
    sum = 0
    @coordinates_array.each_cons(2) do |a,b|
      sum += Map.distance(a,b)
    end
    sum
  end
  def length_string
    l = length
    if l.abs>1000
      "#{(l/1000).round(1)} km"
    else
      "#{l.round(0)} m"
    end
  end
  def the_other_endpoint(endpoint)
    if endpoint==self.first
      self.last
    elsif endpoint==self.last
      self.first
    else
      nil
    end
  end
  def has_endpoint?(point)
    endpoints.include?(point)
  end
  def reverse!
    @coordinates_array.reverse!
    self
  end
end
